var debug = false;

function HashMap() {
    var size = 0;
    var entry = new Object();
    this.put = function (key, value) {
        if (!this.containsKey(key)) {
            size++;
        }
        entry[key] = value;
    }

    this.get = function (key) {
        return this.containsKey(key) ? entry[key] : null;
    }

    this.remove = function (key) {
        if (this.containsKey(key) && (delete entry[key])) {
            size--;
        }
    }

    this.containsKey = function (key) {
        return (key in entry);
    }

    this.containsValue = function (value) {
        for (var prop in entry) {
            if (entry[prop] == value) {
                return true;
            }
        }
        return false;
    }

    this.values = function () {
        var values = new Array();
        for (var prop in entry) {
            values.push(entry[prop]);
        }
        return values;
    }
    this.keys = function () {
        var keys = new Array();
        for (var prop in entry) {
            keys.push(prop);
        }
        return keys;
    }

    this.size = function () {
        return size;
    }

    this.clear = function () {
        size = 0;
        entry = new Object();
    }
}

function StringBuffer() {
    this.str = "";
    this.objArray = new Array();
    this.append = function (s) {
        if (this.length() == 0) {
            this.objArray[0] = s;
        } else {
            this.objArray[this.length() + 1] = s;
        }
    };
    this.toString = function () {
        if (this.length() == 0) {
            return "";
        } else {
            return this.objArray.join("");
        }
    };
    this.chatAt = function (s) {
        if (this.toString() != "") {
            return this.toString().indexOf(s);
        }
    };
    this.clear = function () {
        if (this.length() != 0) {
            this.objArray.length = 0;
        }
    };
    this.length = function () {
        return this.objArray.length;
    };
    this.substring = function (start, end) {
        if (start > 0 || start == 0) {
            if (end <= this.length() && (end > start)) {
                return this.toString().substring(start, end);
            } else {
                alert("JavaScriptException:IndexOutOfBounds");
                return null;
            }
        } else {
            alert("JavaScriptException:IndexOutOfBounds");
            return null;
        }
    };
    this.toArray = function () {
        var tempArray = this.objArray.join(",");
        return tempArray.split(",");
    };
    this.setcharAt = function (charIndex, str) {
        if (charIndex < 0 || charIndex > this.length()) {
            alert("JavaScriptException:IndexOutOfBounds");
            return null;
        } else {
            this.objArray[charIndex] = str;
        }
        return this.toString();
    };
    this.replace = function (oldchar, newchar) {
        var foundChar = this.toString().indexOf(oldchar);
        if (foundChar < 0) {
            alert("JavaScriptException:not found oldchar");
            return null;
        } else {
            return this.toString().replace(oldchar, newchar);
        }
    };
}


// 获取属性值，根据身份证号和KEY
function getItem(key) {
    return localStorage.getItem(key);
}
function setItem(key, value) {
    localStorage.setItem(key, value);
}




function GetColor(number) {
    if (Number(number) > 0) {
        return "red";
    }
    if (Number(number) < 0) {
        return "green";
    }


    return "gray";



}
var isopenselect = false;
var jump2Detail = function (prod_code, prod_kind) {
    if (isopenselect == true) return;
    console.log("code=" + prod_code + " kind=" + prod_kind);
    setItem("request.prod_code", prod_code);
    setItem("request.prod_kind", prod_kind);
    // window.location.href="detail.html";
    window.location.href = "detail.html";
}

function setTableColor(tid) {
    $('#' + tid + ' tr').hover(
                  function () {
                      $(this).addClass("tr_on");
                  },
                  function () {
                      $(this).removeClass("tr_on");
                  }
                );

}

//列头,内容
function SetTableWidth(tid1, tid2, wapid) {



    var Table2 = document.getElementById(tid2);//内容
    var Table1 = document.getElementById(tid1);// 上表头
    var old_height = Table1.offsetHeight;
    if (Table2.rows.length > 0) {
        for (var i = 0; i < Table2.rows[0].cells.length; i++) {
            Table1.rows[0].cells[i].width = Table2.rows[0].cells[i].offsetWidth;
        }
    }

    var new_height = Table1.offsetHeight;


    $("#" + wapid).css("top", ($("#" + wapid).position().top + new_height - old_height) + "px");

}

function isEmpty(content) {
    return content == undefined || content == "";
}


function changeTwoDecimal(x) {
    var f_x = parseFloat(x);
    if (isNaN(f_x)) {
        alert('function:changeTwoDecimal->parameter error');
        return false;
    }
    var f_x = Math.round(x * 100) / 100;

    return f_x;
}


function GetNumberFixed2(number1) {
    return (number1 == "" || number1 == null || number1 == undefined) ? "0.00" : Number(number1).toFixed(2);

}


//必须8位完整转成年月日
function DateFormatNYR(newdate)
{
    return newdate.substring(0, 4) + "年" + newdate.substring(4, 6) + "月" + newdate.substring(6, 8) + "日 ";

}


function sendTCPData(callback,jsonData)
{
    if (!debug) {
        window.plugins.winnerFrame.sendDataByChannel(callback, jsonData, "TCP");
    }
    else {
        SendPacket1(jsonData, function success(json) {
            console.log((JSON.stringify(json)));
            callback(json);
        }, "TCP");
    }
}

function sendSSLData(callback, jsonData)
{
    if (!debug) {
        window.plugins.winnerFrame.sendDataByChannel(callback, jsonData, "SSL");
    }
    else {
        SendPacket1(jsonData, function success(json) {
            alert(JSON.stringify(json));
            callback(json);
        }, "SSL");
    }
}

function buildDateToStr(date) {
    //return date.getFullYear() + "-" + (date.getMonth() < 9 ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1)) + "-" + (date.getDate() < 10 ? "0" + date.getDate() : date.getDate());
    return date.getFullYear().toString() + (date.getMonth() < 9 ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1)).toString() + (date.getDate() < 10 ? "0" + date.getDate() : date.getDate()).toString();
}

function SendPacket1(packet, success,type) {
    $.ajax({
        type: "POST",
        //url: "http://0.html5cachetest.duapp.com/hello",
				//url: "http://localhost/bce_java_default_servlet/hello",
        url: "http://localhost/bce_java_default/DTKAction",
        timeout: 5000,
        contentType: "text/json",
        data: packet,
        cache: false,
        error: function (response) {
            if(response.status != 0)
                alert(response.statusText);
        },
        beforeSend :function(xhr){ 
            xhr.setRequestHeader('connectType', type);
        },
        success: function (json) {
            packet = json;
            //packet = JSON.parse(json);
            success(packet);
        },
        timeout: 20000
    });
}




//得到推荐数据
var queryAdHtml = function (ad_site_id, queryAdHtmlSuccess) {
    //设置入参
    var params = new HashMap();
    params.put("function_id", "730006");
    params.put("ad_site_id", ad_site_id);
    SendPacket(ParamsFormat(params), queryAdHtmlSuccess, function (json) {

    });
}