function UIFrameControl(){
    this.tabBarTag = 0;
    this.tabBarCallbacks = {};
    this.selectedTabBarItem = null;
    this.animationFunc = null;
};

/*********** NavigationBar ******************************************/
/**
 * Create a NavBar.
 */
UIFrameControl.prototype.createNavBar = function(color) 
{
    PhoneGap.exec("UIFrameControl.createNavBar",color);
};

/**
 * set NavBar color.
 */
UIFrameControl.prototype.setNavBarColor = function(color) 
{
    PhoneGap.exec("UIFrameControl.setNavBarColor",color);
};



UIFrameControl.prototype.showSearchBar = function(editingChange,placeholder,value,boardColor) {
    PhoneGap.exec("UIFrameControl.setSearchTitle",editingChange,placeholder,value,boardColor);
};

UIFrameControl.prototype.setSearchBarValue = function(value) {
    PhoneGap.exec("UIFrameControl.setSearchBarValue",value);
};

/**
 * Set up left navigation butuon a NavBar.
 */
UIFrameControl.prototype.setupLeftNavButton = function(title, imageURL, onselect) 
{
    PhoneGap.exec("UIFrameControl.setupLeftNavButton", title, imageURL, onselect);
};

UIFrameControl.prototype.hideLeftNavButton = function() 
{
    PhoneGap.exec("UIFrameControl.hideLeftNavButton");
};

UIFrameControl.prototype.showLeftNavButton = function() 
{
    PhoneGap.exec("UIFrameControl.showLeftNavButton");
};

UIFrameControl.prototype.setupRightNavButton = function(title, imageURL, onselect) 
{
    PhoneGap.exec("UIFrameControl.setupRightNavButton", title, imageURL, onselect);
};


UIFrameControl.prototype.hideRightNavButton = function() 
{
    PhoneGap.exec("UIFrameControl.hideRightNavButton");
};

UIFrameControl.prototype.showRightNavButton = function() 
{
    PhoneGap.exec("UIFrameControl.showRightNavButton");
};

/**
 * 设置标题
 */
UIFrameControl.prototype.setNavBarTitle = function(title) 
{
    PhoneGap.exec("UIFrameControl.setNavBarTitle", title);
};

/**
 * Function called to set the title of the navBar
 * @param {String} imageURL full URL to the image 
 */
UIFrameControl.prototype.setNavBarLogo = function(imageURL) 
{
    PhoneGap.exec("UIFrameControl.setNavBarLogo", imageURL);
};

/**
 * Show a nav bar.  The nav bar has to be created first.
 * @param none 
 */
UIFrameControl.prototype.showNavBar = function() {
    PhoneGap.exec("UIFrameControl.showNavBar");
};

/**
 * Hide a nav bar.  The nav bar has to be created first.
 */
UIFrameControl.prototype.hideNavBar = function() {
    
    PhoneGap.exec("UIFrameControl.hideNavBar");
};


/*********** TabBar ************************************************/
/**
 * Create a native tab bar that can have tab buttons added to it which can respond to events.
 */
UIFrameControl.prototype.createTabBar = function(color) {
    PhoneGap.exec("UIFrameControl.createTabBar",color);
};

/**
 * Show a tab bar.  The tab bar has to be created first.
 * @param {Object} [options] Options indicating how the tab bar should be shown:
 * - \c height integer indicating the height of the tab bar (default: \c 49)
 * - \c position specifies whether the tab bar will be placed at the \c top or \c bottom of the screen (default: \c bottom)
 */
UIFrameControl.prototype.showTabBar = function(options) {
    if (!options) options = {'position' : 'bottom'};
    PhoneGap.exec("UIFrameControl.showTabBar", options);
};


/**
 * Hide a tab bar.  The tab bar has to be created first.
 */
UIFrameControl.prototype.hideTabBar = function(animate) {
    if (animate == undefined || animate == null)
        animate = true;
    PhoneGap.exec("UIFrameControl.hideTabBar", { animate: animate });
};


/**
 * Create a new tab bar item for use on a previously created tab bar.  Use ::showTabBarItems to show the new item on the tab bar.
 *
 * If the supplied image name is one of the labels listed below, then this method will construct a tab button
 * using the standard system buttons.  Note that if you use one of the system images, that the \c title you supply will be ignored.
 *
 * <b>Tab Buttons</b>
 *   - tabButton:More
 *   - tabButton:Favorites
 *   - tabButton:Featured
 *   - tabButton:TopRated
 *   - tabButton:Recents
 *   - tabButton:Contacts
 *   - tabButton:History
 *   - tabButton:Bookmarks
 *   - tabButton:Search
 *   - tabButton:Downloads
 *   - tabButton:MostRecent
 *   - tabButton:MostViewed
 * @param {String} name internal name to refer to this tab by
 * @param {String} [title] title text to show on the tab, or null if no text should be shown
 * @param {String} [image] image filename or internal identifier to show, or null if now image should be shown
 * @param {Object} [options] Options for customizing the individual tab item
 *  - \c badge value to display in the optional circular badge on the item; if null or unspecified, the badge will be hidden
 */
UIFrameControl.prototype.createTabBarItem = function(name, label, image, options) {
    
	var tag = this.tabBarTag++;
    if (options && 'onSelect' in options && typeof(options['onSelect']) == 'function') {
        this.tabBarCallbacks[tag] = {'onSelect':options.onSelect,'name':name};
        //delete options.onSelect;
    }
	
    PhoneGap.exec("UIFrameControl.createTabBarItem", name, label, image, tag);
};

/**
 * Update an existing tab bar item to change its badge value.
 * @param {String} name internal name used to represent this item when it was created
 * @param {Object} options Options for customizing the individual tab item
 *  - \c badge value to display in the optional circular badge on the item; if null or unspecified, the badge will be hidden
 */
UIFrameControl.prototype.updateTabBarItem = function(name, options) {
    if (!options) options = {};
    PhoneGap.exec("UIFrameControl.updateTabBarItem", name, options);
};

/**
 * Show previously created items on the tab bar
 * @param {String} arguments... the item names to be shown
 * @param {Object} [options] dictionary of options, notable options including:
 *  - \c animate indicates that the items should animate onto the tab bar
 * @see createTabBarItem
 * @see createTabBar
 */
UIFrameControl.prototype.showTabBarItems = function() {
    var parameters = [ "UIFrameControl.showTabBarItems" ];
    for (var i = 0; i < arguments.length; i++) {
        parameters.push(arguments[i]);
    }
    
    PhoneGap.exec.apply(this, parameters);
};

/**
 * Function to detect currently selected tab bar item
 * @see createTabBarItem
 * @see showTabBarItems
 */
UIFrameControl.prototype.getSelectedTabBarItem = function() {
    return this.selectedTabBarItem;
};

/**
 * Manually select an individual tab bar item, or nil for deselecting a currently selected tab bar item.
 * @param {String} tabName the name of the tab to select, or null if all tabs should be deselected
 * @see createTabBarItem
 * @see showTabBarItems
 */
UIFrameControl.prototype.selectTabBarItem = function(tab) {
    PhoneGap.exec("UIFrameControl.selectTabBarItem", tab);
};

/**
 * Function called when a tab bar item has been selected.
 * @param {Number} tag the tag number for the item that has been selected
 */
UIFrameControl.prototype.tabBarItemSelected = function(tag) 
{
	this.selectedTabBarItem = tag;
    if (typeof(this.tabBarCallbacks[tag].onSelect) == 'function')
        this.tabBarCallbacks[tag].onSelect(this.tabBarCallbacks[tag].name,tag);
};

/**
 * 转场动画操作
 * @param   : callbackFunc --- 回调函数名
 * @param   : duration      --- 动画执行时间
 * @param   : animationType --- 动画类型（参数如下，大小写不敏感）
 *                           fade
                             moveIn
                             push
                             Reveal
                             pageCurl 向上翻一页
                             pageUnCurl 向下翻一页
                             rippleEffect 滴水效果
                             suckEffect 收缩效果，如一块布被抽走
                             cube 立方体效果
                             oglFlip 翻转效果
 
 * @param   : subAnimationType --- 动画子类型（参数如下，对有些没有方向性的动画不起效）
             fromRight --- 从右边往左
             fromLeft --- 从左边向右
             fromTop ---- 从下往下
             fromBottom --- 从下往上
 
 */
UIFrameControl.prototype.turnPageAnimation = function(callBackFunc,duration,animationType,subAnimatonType){
    if(typeof(callBackFunc) == 'function'){
        this.animationFunc = callBackFunc;
        //PhoneGap.exec("UIFrameControl.turnPageAnimation", "window.plugins.uiFrameControl.animationCallback",duration,animationType,subAnimatonType);
        callBackFunc();
    }
    else if(typeof(callBackFunc) == 'object'){
        this.animationFunc = {obj:callBackFunc};
        PhoneGap.exec("UIFrameControl.turnPageAnimation", "window.plugins.uiFrameControl.animationCallback",duration,animationType,subAnimatonType);
    }else{
        PhoneGap.exec("UIFrameControl.turnPageAnimation", callBackFunc,duration,animationType,subAnimatonType);
    }
}

UIFrameControl.prototype.webViewAnimation = function(callBackFunc,duration,animationType,subAnimatonType){
    if(typeof(callBackFunc) == 'function'){
        this.animationFunc = callBackFunc;
        PhoneGap.exec("UIFrameControl.performWebViewAnimation", "window.plugins.uiFrameControl.animationCallback",duration,animationType,subAnimatonType);
    }
    else if(typeof(callBackFunc) == 'object'){
        this.animationFunc = {obj:callBackFunc};
        PhoneGap.exec("UIFrameControl.performWebViewAnimation", "window.plugins.uiFrameControl.animationCallback",duration,animationType,subAnimatonType);
    }
    else{
        PhoneGap.exec("UIFrameControl.performWebViewAnimation", callBackFunc,duration,animationType,subAnimatonType);
    }
}

UIFrameControl.prototype.animationCallback = function(){
    
    if(typeof(this.animationFunc) == 'function'){
        this.animationFunc();
    }
    else if(typeof(this.animationFunc) == 'object'){
        this.animationFunc.obj.onStartAnimation();
    }
    
}

/************** 二级菜单 ************/

UIFrameControl.prototype.createToolBarMenu = function(callback,color,bgimage,titles){
    PhoneGap.exec("UIFrameControl.createToolBarMenu",callback,color,bgimage,titles);
}

UIFrameControl.prototype.showToolBarMenu = function(){
    PhoneGap.exec("UIFrameControl.showToolBarMenu");
}

UIFrameControl.prototype.hideToolBarMenu = function(){
    PhoneGap.exec("UIFrameControl.hideToolBarMenu");
}

UIFrameControl.prototype.updateToolBarItems = function(callback,titles){
    PhoneGap.exec("UIFrameControl.updateToolBarItems",callback,titles);
}

/*******************************************************************/


PhoneGap.addConstructor(function(){
                        if(!window.plugins){
                        window.plugins = {};
                        }
                        
                        window.plugins.uiFrameControl = new UIFrameControl();
                        
                        }
                        );

/*******************************************************************/